unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    ComboBox1: TComboBox;
    FontDlg: TFontDialog;
    pnl4memos: TPanel;
    ScrollBox1: TScrollBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ComboBox1CloseUp(Sender: TObject);
  private

    procedure AdapteFontSizeMemo(FontSize: Integer; Sender: TObject);
    procedure AdapteHauteurMemo(Sender: TObject);

    function GetVirtualTextWidth(S: String; afont:TFont): Integer;
    function GetVirtualTextHeight(afont:TFont): Integer;

  protected
    MemosContainer : Array[0..2] of TMemo;
  public
    procedure CreateMemos;
    procedure FillMemos;
  end;


Const
  cText : String = 'Ne dirait-on pas, à chaque voyage, il fut pris d''un grand pouvoir. '+
                   'Tenez-vous-en à votre plan dans son entier, remettre et retenir le '+
                   'saint service  selon la forme et de volume, produisant pour ainsi dire '+
                   'violemment en arrière en poussant un gros soupir.';

var
  Form1: TForm1;

implementation

{$R *.lfm}
uses math;
{ TForm1 }

procedure TForm1.ComboBox1CloseUp(Sender: TObject);
var
  i, cnt,h, nbligne : integer;
  Obj : TObject;
begin
  cnt := ScrollBox1.ControlCount-1;
  //Showmessage('ControlCount : '+inttostr(cnt));
  if cnt>0 then
  begin
    For i:=0 to cnt do
    begin
      Obj := ScrollBox1.Controls[I];
      if (Obj is TMemo) then
      begin
        With (Obj As TMemo) do
        begin
          Font.Size:= StrToInt(ComboBox1.Text);
          //ShowMessage('ClientWidth : ' + Inttostr(ClientWidth));
          nbLigne := round((GetVirtualTextWidth(Text, Font) / ClientWidth)+0.5);
            // 8 = marge haut/bas, 2 = hauteur entre les lignes
          {$ifdef unix}
            h := 4+(2*(nbligne-1)) + (nbLigne * (Font.size* 2));//GetVirtualTextHeight(Font));
          {$else}
            h := 4+(2*(nbligne-1)) + (nbLigne * GetVirtualTextHeight(Font));
          {$endif}
          //ShowMessage('Lines : ' + Inttostr(nbligne)+' - Height = '+inttostr(h));
          Height:= h;
        end;
        //AdapteFontSizeMemo(StrToInt(ComboBox1.Text), Obj);
        //AdapteHauteurMemo(obj);
        //ShowMessage('Memo '+inttostr(i+1)+' Height : '+inttostr(TMemo(Obj).Height));
      end;
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  CreateMemos;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  FillMemos;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  h, nbligne : integer;
begin
  if fontdlg.Execute then
  begin
    With MemosContainer[TButton(Sender).Tag] do
    begin
      Font := fontdlg.Font;
     // ShowMessage('Text Width : ' + Inttostr(GetVirtualTextWidth(Text, Font))+' Client Width : '+inttostr(ClientWidth));
      nbLigne := round((GetVirtualTextWidth(Text, Font) / ClientWidth)+0.5);
     // ShowMessage('Floor : '+inttostr(nbligne));
     // Showmessage('Round : '+inttostr(round((GetVirtualTextWidth(Text, Font) / ClientWidth)+0.5)));
        // 8 = marge haut/bas, 2 = hauteur entre les lignes
      {$ifdef unix}
        h := 4+(2*(nbligne-1)) + (nbLigne * (Font.size* 2));//GetVirtualTextHeight(Font));
      {$else}
        h := 4+(2*(nbligne-1)) + (nbLigne * GetVirtualTextHeight(Font));
      {$endif}
      //ShowMessage('Lines : ' + Inttostr(nbligne)+' - Height = '+inttostr(h));
      Height:= h;
    end;
    //AdapteHauteurMemo(MemosContainer[TButton(Sender).Tag]);
    //ShowMessage('Size change Memo '+inttostr(TButton(Sender).Tag+1)+' Height : '+inttostr(MemosContainer[TButton(Sender).Tag].Height));
  end;
end;

procedure TForm1.AdapteFontSizeMemo(FontSize: Integer; Sender: TObject);
begin
  TMemo(Sender).Font.Size:= FontSize;
  //AdapteHauteurMemo(Sender);
end;

procedure TForm1.AdapteHauteurMemo(Sender: TObject);
var
  nbligne, i : integer;
  mmo : TMemo;
begin
  mmo := TMemo(Sender);
  nbLigne := round((GetVirtualTextWidth(mmo.Text, mmo.Font) / mmo.ClientWidth)+0.5);
  // 8 = marge haut/bas, 2 = hauteur entre les lignes
  I := 4+(2*(nbligne-1)) + (nbLigne * GetVirtualTextHeight(mmo.Font));
  ShowMessage('Lines : ' + Inttostr(nbligne)+' - Height = '+inttostr(i));
  mmo.Height:= I;

end;

function TForm1.GetVirtualTextWidth(S: String; afont : TFont): Integer;
var
  c: TBitmap;
begin
  c := TBitmap.Create;
  try
    //c.Canvas.Font.Assign(aFont);
    c.Canvas.Font := afont;
    result := (c.Canvas.TextWidth(S));
    //ShowMessage('Text Width : ' + Inttostr(result));
  finally
    c.Free;
  end;
end;

function TForm1.GetVirtualTextHeight(afont: TFont): Integer;
var
  c: TBitmap;
begin
  c := TBitmap.Create;
  try
    //c.Canvas.Font.Assign(aFont);
    c.Canvas.Font := afont;
   result := (c.Canvas.TextHeight('pTMyJji!,²ô}'));
   //ShowMessage('Text Height : ' + Inttostr(result));
  finally
    c.Free;
  end;
end;

procedure TForm1.CreateMemos;
var
  i:integer;
begin
  For i:=0 to 2 do
  begin
    MemosContainer[i] := TMemo.Create(Self);
    With MemosContainer[i] do
    begin
      Parent := ScrollBox1;
      Align := alTop;
      Height := 100;
      Lines.Clear;
      WordWrap := True;
    end;
  end;
end;

procedure TForm1.FillMemos;
var
  i:integer;
begin
  For i:=0 to 2 do
  begin
    With MemosContainer[i] do
    begin
      Lines.Text := cText;

    end;
    //AdapteHauteurMemo(MemosContainer[i]);
  end;
  ComboBox1CloseUp(MemosContainer[i])
end;

end.

